<template>
    <div>
        <div class="range-box">
            <p>Діапазон цін</p>
            <div>
              <div class="range-slider">
                <input
                    type="range"
                    min="0"
                    max="2000"
                    step="20"
                    v-model.number="rangePrice.min"
                    @change="setRangeSlider"
                >
                <input
                    type="range"
                    min="0"
                    max="2000"
                    step="20"
                    v-model.number="rangePrice.max"
                    @change="setRangeSlider"
                >
              </div>
              <div class="filters">
                <div>Min: {{rangePrice.min}}</div>
                <div>Max: {{rangePrice.max}}</div>
              </div>
            </div>
        </div>

        <div class="product-list">
            <Product
                v-for="product in filterProducts"
                :key="product.id"
                :product="product"
                @delete-product="openModal"
                @send-product-id="getProductInBasket"
            />
        </div>
        <div>
            <Pagination
                :page="page"
                @set-page="setPage"
            />
        </div>
        <modal-confirm-delete v-if="showModal">
            <template v-slot:header>
                Видалення товару
            </template>
            <template v-slot:body>
                {{ `Ви дійсно бажаєте видалити цей товар назавжди?` }}

            </template>
            <template v-slot:footer="props">
                <button class="btn btn-info" @click="confirmedDelete">
                    Так
                </button>
                <button class="btn btn-default" @click="showModal = false">
                    Відмінити
                </button>
            </template>
        </modal-confirm-delete>
    </div>
</template>

<script>
import Product from "@/components/products/Product.vue";
import Pagination from "@/components/products/Pagination.vue";
import { mapActions, mapGetters } from 'vuex';
import ModalConfirmDelete from "@/components/products/ModalConfirmDelete.vue";

export default {
    name: "ProductList",
    components: {
        ModalConfirmDelete,
        Product,
        Pagination,
    },
    data() {
        return {
            page: 1,
            showModal: false,
            deleteProduct: {},
            filterProducts: {},
            rangePrice: {
                min: 0,
                max: 2000,
            },
            productInBasket: {},
        }
    },
    computed: {
        ...mapGetters({
            products: 'getProducts',
            searchValue: 'getSearchValue',
            basket: 'getBasket'
        }),
    },
    mounted() {
        this.loadData();
        this.setDefaults();
    },
    methods: {
        ...mapActions([
            'getProducts',
        ]),
        setPage(page) {
            this.page = page;
            this.loadData();
        },
        loadData() {
            let vm = this;
            this.getProducts(this.page);
        },
        openModal(event) {
            this.showModal = true;
            this.deleteProduct = event;
        },
        confirmedDelete() {
            this.$store.dispatch('deleteProduct', this.deleteProduct);
            this.showModal = false;
        },
        sortProducts(value, products, rangePrice) {
            let fproducts = products.filter(function(product) {
                return product.price >= rangePrice.min && product.price <= rangePrice.max;
            });
            if(value) {
                fproducts = fproducts.filter(function (product) {
                    return product.name.toLowerCase().includes(value.toLowerCase());
                })
            }
            return fproducts;
        },
        setDefaults() {
            this.filterProducts = {...this.products};
            this.$store.dispatch('setSearchValue', null);
        },
        setRangeSlider() {
            if(this.rangePrice.min > this.rangePrice.max) {
                let tmp = this.rangePrice.max;
                this.rangePrice.max = this.rangePrice.min;
                this.rangePrice.max = tmp;
            }

        },
        filterProd() {
            this.filterProducts = this.sortProducts(this.searchValue, this.products, this.rangePrice);
        },
        getProductInBasket(data) {
            this.productInBasket = data;
            this.$emit('getProductInBasket', this.productInBasket);
        },

    },
    watch: {
        searchValue: {
            handler() {
                this.filterProd();
            },
            deep: true,
        },

        rangePrice: {
            handler(val) {
                if(val.min > val.max) {
                    const temp = val.min;
                    val.min = val.max;
                    val.max = temp;
                }
                this.filterProd();
            },
            deep: true,
        },
        products() {
          this.filterProd();
        }

    }
}
</script>

<style>
    .product-list {
        margin-top: 20px;
        display: grid;
        grid-template-columns: repeat(3, 1fr);
        gap: 10px;
    }

    .filters{
        display: flex;
        justify-content: right;
        align-items: center;
        gap: 40px;
        font-size: 16px;
    }

    .range-slider {
        width: 150px;
        margin: auto 16px;
        text-align: center;
        position: relative;
        right: 0;
    }

    .range-slider svg, .range-slider input[type=range] {
        position: absolute;
        right: 0;
        bottom: 0;
    }

    input[type=range]::-webkit-slider-thumb {
        z-index: 2;
        position: relative;
        top: 2px;
        margin-top: -7px;
    }

    .range-box {
      position: relative;
      right: -1000px;
      text-align: center;
      width: 200px;
    }
</style>
